    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * --------------------
    028 * PieURLGenerator.java
    029 * --------------------
    030 * (C) Copyright 2002-2008, by Richard Atkinson and Contributors.
    031 *
    032 * Original Author:  Richard Atkinson;
    033 * Contributors:     David Gilbert (for Object Refinery Limited);
    034 *
    035 * Changes:
    036 * --------
    037 * 05-Aug-2002 : Version 1, contributed by Richard Atkinson;
    038 * 09-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    039 * 07-Mar-2003 : Modified to use KeyedValuesDataset and added pieIndex
    040 *               parameter (DG);
    041 * 24-Apr-2003 : Switched around PieDataset and KeyedValuesDataset (DG);
    042 * ------------- JFREECHART 1.0.x ---------------------------------------------
    043 * 24-Nov-2006 : Updated API docs (DG);
    044 * 13-Dec-2007 : Updated API docs (DG);
    045 *
    046 */
    047
    048package org.jfree.chart.urls;
    049
    050import org.jfree.data.general.PieDataset;
    051
    052/**
    053 * Interface for a URL generator for plots that use data from a
    054 * {@link PieDataset}.  Classes that implement this interface:
    055 * <ul>
    056 * <li>are responsible for correctly escaping any text that is derived from the
    057 *     dataset, as this may be user-specified and could pose a security
    058 *     risk;</li>
    059 * <li>should be either (a) immutable, or (b) cloneable via the
    060 *     <code>PublicCloneable</code> interface (defined in the JCommon class
    061 *     library).  This provides a mechanism for the referring plot to clone
    062 *     the generator if necessary.</li>
    063 * </ul>
    064 */
    065public interface PieURLGenerator {
    066
    067    /**
    068     * Generates a URL for one item in a {@link PieDataset}. As a guideline,
    069     * the URL should be valid within the context of an XHTML 1.0 document.
    070     *
    071     * @param dataset  the dataset (<code>null</code> not permitted).
    072     * @param key  the item key (<code>null</code> not permitted).
    073     * @param pieIndex  the pie index (differentiates between pies in a
    074     *                  'multi' pie chart).
    075     *
    076     * @return A string containing the URL.
    077     */
    078    public String generateURL(PieDataset dataset, Comparable key, int pieIndex);
    079
    080}